// KENSHIN! from the manga Rurouni Kenshin. Himura Kenshin the sword wielding assassin who changed his ways.
// Rip of {HOJ}Batman's Wolverine

/* CVARS - copy and paste to shconfig.cfg

//Kenshin
kenshin_level 0 
kenshin_knifespeed 500		//Speed of Kenshin in knife mode (Default 500)
kenshin_knifemult 3.0		//Multiplier for knife damage (Default 3.0)

*/

// v1.2 - vittu - code cleaned up

#include <amxmod>
#include <superheromod>

// GLOBAL VARIABLES
new g_heroName[]="Kenshin"
new bool:g_hasKenshinPower[SH_MAXSLOTS+1]
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Kenshin", "1.2", "eLiTe-VeLoCiTy")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("kenshin_level", "0")
	register_cvar("kenshin_knifespeed", "500")
	register_cvar("kenshin_knifemult", "3.0")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	shCreateHero(g_heroName, "Kenshin Sword", "Extra Knife Damage, Extra Knife Speed", false, "kenshin_level")

	// REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
	// INIT
	register_srvcmd("kenshin_init", "kenshin_init")
	shRegHeroInit(g_heroName, "kenshin_init")

	// EXTRA KNIFE DAMAGE
	register_event("Damage", "kenshin_damage", "b", "2!0")

	// Let Server know about Kenshins max knife speed
	shSetMaxSpeed(g_heroName, "kenshin_knifespeed", "[29]")
}
//----------------------------------------------------------------------------------------------
public kenshin_init()
{
	// First Argument is an id
	new temp[6]
	read_argv(1,temp,5)
	new id = str_to_num(temp)

	// 2nd Argument is 0 or 1 depending on whether the id has the hero
	read_argv(2,temp,5)
	new hasPowers = str_to_num(temp)

	// Got to slow down a Wolverine that lost his powers...
	if ( !hasPowers  && g_hasKenshinPower[id]  && is_user_connected(id) ) {
		shRemSpeedPower(id)
	}
	//Sets this variable to the current status
	g_hasKenshinPower[id] = (hasPowers != 0)
}
//----------------------------------------------------------------------------------------------
public kenshin_damage(id)
{
	if ( !shModActive() || !is_user_alive(id) ) return

	new damage = read_data(2)
	new weapon, bodypart, attacker = get_user_attacker(id, weapon, bodypart)
	new headshot = bodypart == 1 ? 1 : 0

	if ( attacker <= 0 || attacker > SH_MAXSLOTS ) return

	if ( g_hasKenshinPower[attacker] && weapon == CSW_KNIFE && is_user_alive(id) ) {
		// do extra damage
		new extraDamage = floatround(damage * get_cvar_float("kenshin_knifemult") - damage)
		if ( extraDamage > 0 ) shExtraDamage(id, attacker, extraDamage, "knife", headshot)
	}
}
//----------------------------------------------------------------------------------------------