// The Mask! -- From The Movie With Jim Carrey
// Credit goes to Gorlag/Batman for help me with the cooldown and weaponchange part
// Credit also goes to Emp` who helped me with the damage part
// And also thanks to vittu for the finishing touch :D

/* CVARS - copy and paste to shconfig.cfg

//The Mask
themask_level 10
themask_health 300				//How much hp he will get
themask_armor 999				//How much ap he will get
themask_speed 600				//How fast he will be
themask_cooldown 60				//# of seconds for The Mask's cooldown
themask_uspmult	3				//Multiplyer for the USP
themask_glock18mult 3.5			//Multiplyer for the Glock18
themask_mp5navymult 1.3			//Multiplyer for the Mp5navy

*/

/*
/
/	v1.3 - The last touch by vittu at the damage part ;)
/
/	v1.2 - Fixed Damage part with the help of Emp`
/
/	v1.1 - Fixed Cooldown and weaponchange part with the help of Gorlag/Batman
/
*/

#include <amxmod>
#include <superheromod>

// GLOBAL VARIABLES
new gHeroName[]="The Mask"
new bool:gHasMaskPowers[SH_MAXSLOTS+1]
new gMaskUltimate[SH_MAXSLOTS+1]
new bool:gDamage1[SH_MAXSLOTS+1]
new bool:gDamage2[SH_MAXSLOTS+1]
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO The Mask","1.3","-]Tical2k[- DooM")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("themask_level", "10" )
	register_cvar("themask_health", "300" )
	register_cvar("themask_armor", "999" )
	register_cvar("themask_speed", "600" )
	register_cvar("themask_cooldown", "60" )
	register_cvar("themask_uspmult", "3" )
	register_cvar("themask_glock18mult", "3.5" )
	register_cvar("themask_mp5navymult", "1.3" )

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	shCreateHero(gHeroName, "Choose!", "You will have a menu with nice opportunities.", true, "themask_level" )

	// INIT
	register_srvcmd("mask_init", "mask_init")
	shRegHeroInit(gHeroName, "mask_init")

	// EVENTS
   	register_event("Damage", "themask_Damage", "b", "2!0")
   	register_event("CurWeapon", "WeaponChange", "be", "1=1")
	register_event("DeathMsg", "Death", "a")
	register_event("ResetHUD","NewRound","b")

	// MENU
	register_menucmd(register_menuid("The Mask's Opportunities"), 1023, "main_menu_action")

	// KEYDOWN
	register_srvcmd("mask_kd", "mask_kd")
	shRegKeyDown(gHeroName, "mask_kd")
}
//----------------------------------------------------------------------------------------------
public mask_init()
{
	// First Argument is an id
	new temp[6]
	read_argv(1,temp,5)
	new id = str_to_num(temp)

	// 2nd Argument is 0 or 1 depending on whether the id has wolverine skills
	read_argv(2,temp,5)
	new hasPowers = str_to_num(temp)

	//This gets run if they had the power but don't anymore
	if ( !hasPowers && gHasMaskPowers[id] ) {
		engclient_cmd(id, "drop", "weapon_usp")
		engclient_cmd(id, "drop", "weapon_glock18")
		engclient_cmd(id, "drop", "weapon_mp5navy")
		shRemHealthPower(id)
		shRemArmorPower(id)
		shRemSpeedPower(id)
		}
			
	//Sets this variable to the current status
	gHasMaskPowers[id] = (hasPowers != 0)
}
//----------------------------------------------------------------------------------------------
public NewRound(id)
{
	gPlayerUltimateUsed[id] = false
	gDamage1[id] = false
	gDamage2[id] = false
}
//----------------------------------------------------------------------------------------------
public mask_kd()
{
	// First Argument is an id
	new temp[6]
	read_argv(1,temp,5)
	new id = str_to_num(temp)

	if ( !is_user_alive(id) ) return
	
	if ( gPlayerUltimateUsed[id] )
	{
		playSoundDenySelect(id)
		return
	}

	// Make sure they're not in the middle of FOXMODE already
	if ( gMaskUltimate[id]>0 ) return

	show_main_menu(id)
	ultimateTimer(id, get_cvar_num("themask_cooldown") * 1.0)
	
	return
}
//----------------------------------------------------------------------------------------------
public show_main_menu(id)
{
	new menu_body[320]
	new n = 0
	new len = 319

	if ( !gHasMaskPowers[id] || !is_user_alive(id) ) return

	n += format(menu_body[n], len-n, "\rThe Mask's Opportunities^n", " ")
	n += format(menu_body[n], len-n, "^n\w1. More HP")
	n += format(menu_body[n], len-n, "^n2. More AP")
	n += format(menu_body[n], len-n, "^n3. More Speed")
	n += format(menu_body[n], len-n, "^n4. More DMG for USP & Glock")
	n += format(menu_body[n], len-n, "^n5. More DMG for Mp5navy")
	n += format(menu_body[n], len-n, "^n^n0. Exit")

	new keys = (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<9)

	show_menu(id, keys, menu_body)
}
//----------------------------------------------------------------------------------------------
public main_menu_action(id, key)
{
	key++

	if ( !shModActive() || !gHasMaskPowers[id] || !is_user_alive(id) ) return

	switch(key){
		case 1: {
			themask_health(id)
		}
		case 2: {
			themask_armor(id)
		}
		case 3: {
			themask_speed(id)
		}
		case 4: {
			themask_ability(id)
			gDamage1[id] = true
		}
		case 6: {
			themask_ability2(id)
			gDamage2[id] = true
		}
		case 10: return
		default: show_main_menu(id)
	}
}
//----------------------------------------------------------------------------------------------
public WeaponChange(id)
{
	if ( !gHasMaskPowers[id] || !shModActive() ) return

	new wpnid = read_data(2)
	new clip = read_data(3)

	if (wpnid != CSW_USP && wpnid != CSW_GLOCK18 && wpnid != CSW_MP5NAVY) return
	
	// Never Run Out of Ammo!
	if ( clip == 0 ) {
		shReloadAmmo(id)
	}
}
//----------------------------------------------------------------------------------------------
public themask_health(id)
{
	set_user_health(id, get_cvar_num("themask_health"))
		
	// This is here that the person sees what he/she chose
	new message[128]
	format(message, 127, "The Mask - You decided to take more hp. Nice Choice!")
	set_hudmessage(157,50,250,-1.0,0.3,0,0.25,1.0,0.0,0.0,4)
	show_hudmessage(id, message)
}
//----------------------------------------------------------------------------------------------
public themask_armor(id)
{
	give_item(id, "item_assaultsuit")
	set_user_armor(id, get_cvar_num("themask_armor"))
		
	// This is here that the person sees what he/she chose
	new message[128]
	format(message, 127, "The Mask - You decided to take more ap. Nice Choice!")
	set_hudmessage(255,255,255,-1.0,0.3,0,0.25,1.0,0.0,0.0,4)
	show_hudmessage(id, message)
}
//----------------------------------------------------------------------------------------------
public themask_speed(id)
{
	server_cmd("sh_setmaxspeed ^"%s^" ^"%s^" ^"%s^"", gHeroName, "themask_speed", "[0]" )
			
	// This is here that the person sees what he/she chose
	new message[128]
	format(message, 127, "The Mask - You decided to take more speed. Nice Choice!")
	set_hudmessage(255,255,0,-1.0,0.3,0,0.25,1.0,0.0,0.0,4)
	show_hudmessage(id, message)
}
//----------------------------------------------------------------------------------------------
public themask_ability(id)
{
	if ( is_user_alive(id) ) {
		shGiveWeapon(id, "weapon_usp")
		shGiveWeapon(id, "weapon_glock18")
		
	// This is here that the person sees what he/she chose
		new message[128]
		format(message, 127, "The Mask - You decided to take more dmg for USP & Glock18. Nice Choice!")
		set_hudmessage(18,240,167,-1.0,0.3,0,0.25,1.0,0.0,0.0,4)
		show_hudmessage(id, message)
	}
}	
//----------------------------------------------------------------------------------------------
public themask_ability2(id)
{
	if ( is_user_alive(id) ) {
		shGiveWeapon(id, "weapon_mp5navy")
	
	// This is here that the person sees what he/she chose
		new message[128]
		format(message, 127, "The Mask - You decided to take more dmg for Mp5navy. Nice Choice!")
		set_hudmessage(255,255,0,-1.0,0.3,0,0.25,1.0,0.0,0.0,4)
		show_hudmessage(id, message)
	}
}	
//----------------------------------------------------------------------------------------------
public themask_Damage(id)
{
      new damage = read_data(2)
      new body, weapon, attacker = get_user_attacker(id, weapon, body)
      new headshot = body == 1 ? 1 : 0

      if ( attacker > 0 && attacker <= SH_MAXSLOTS && is_user_alive(attacker) && attacker != id ) {
         if (gDamage1[attacker]){
            if(weapon==CSW_USP){
               new extraDamage = floatround(damage * get_cvar_float("themask_uspmult") - damage)
               if (extraDamage > 0) shExtraDamage( id, attacker, extraDamage, "usp", headshot )
               }
            if(weapon==CSW_GLOCK18){
               new extraDamage = floatround(damage * get_cvar_float("themask_glock18mult") - damage)
               if (extraDamage > 0) shExtraDamage( id, attacker, extraDamage, "glock18", headshot )
               }
         }
         else if (gDamage2[attacker] && weapon==CSW_MP5NAVY){
            new extraDamage = floatround(damage * get_cvar_float("themask_mp5navymult") - damage)
            if (extraDamage > 0) shExtraDamage( id, attacker, extraDamage, "mp5navy", headshot )
         }
      }
}
//----------------------------------------------------------------------------------------------
public Death()
{
	new id = read_data(2)

	gPlayerUltimateUsed[id] = false
	gDamage1[id] = false
	gDamage2[id] = false

	if ( !gHasMaskPowers[id] ) return
}
//---------------------------------------------------------------------------------------------