// SCARLET SPIDER!

/* CVARS - copy and paste to shconfig.cfg

//Scarlet Spider
scarlet_level 6
scarlet_wallspeed 250.0				//speed he climbs

*/

#include <amxmod>
#include <Vexd_Utilities>
#include <superheromod>

#if !defined AMX_NEW
	#include <xtrafun>  //Only for the constants, doesn't use any functions
#endif

new gHeroName[]="Scarlet Spider"
new bool:g_hasScarletPower[SH_MAXSLOTS+1]
new bool:g_canClimb[SH_MAXSLOTS+1]

public plugin_init() {
	// Plugin Info
	register_plugin("SUPERHERO Scarlet Spider","1.0","-=cKy=- <Killer>")
	
	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("scarlet_level", "6")
	register_cvar("scarlet_wallspeed", "250.0")
	
	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	shCreateHero(gHeroName, "Walk up walls", "Press the bound key and run into a wall to climb up it!", true, "scarlet_level" )

	// REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
	register_event("ResetHUD","newRound","b")
	
	register_srvcmd("scarlet_init", "scarlet_init")
	shRegHeroInit(gHeroName, "scarlet_init")

	// KEY DOWN
	register_srvcmd("scarlet_kd", "scarlet_kd")
	shRegKeyDown(gHeroName, "scarlet_kd")
}
public scarlet_init() {
	// First Argument is an id
	new temp[6]
	read_argv(1,temp,5)
	new id = str_to_num(temp)

	// 2nd Argument is 0 or 1 depending on whether the id has Beast
	read_argv(2,temp,5)
	new hasPowers = str_to_num(temp)
	g_hasScarletPower[id]=(hasPowers!=0)
	g_canClimb[id]=false
}

public wall_walk(id) {
	if ( is_user_alive(id) && g_hasScarletPower[id] && g_canClimb[id]) {
		
		new Float:velocity[3]
		Entvars_Get_Vector(id, EV_VEC_velocity, velocity)
		if ( (Entvars_Get_Int(id,EV_INT_button)&IN_FORWARD) && (velocity[0]==0.0 || velocity[1]==0.0) ) {
			velocity[2]=get_cvar_float("scarlet_wallspeed")
			Entvars_Set_Vector(id, EV_VEC_velocity, velocity)
		}
	}
}

public scarlet_kd() {
	// First Argument is an id with Mystique Powers!
	new temp[6]
	read_argv(1,temp,5)
	new id=str_to_num(temp)
	if ( !is_user_alive(id) || !g_hasScarletPower[id] ) return PLUGIN_HANDLED
	
	if ( !g_canClimb[id] ) {
		g_canClimb[id]=true
		set_task(0.1,"wall_walk",id,"",0,"b")
		set_hudmessage(20, 255, 20, -1.0, 0.25, 0, 1.0, 1.2, 0.4, 0.4, 95)
		show_hudmessage(id, "You can now walk up walls!")
		return PLUGIN_HANDLED
	}
	
	g_canClimb[id]=false
	remove_task(id)
	set_hudmessage(20, 255, 20, -1.0, 0.25, 0, 1.0, 1.2, 0.4, 0.4, 95)
	show_hudmessage(id, "You got rid of your ability to walk up walls")
	return PLUGIN_HANDLED
}

public client_disconnect(id) {
	remove_task(id)
}

public newRound(id) {
	g_canClimb[id]=false
}