#include <amxmod>
#include <superheromod>

/*

//Silver Surfer
surfer_level 10
surfer_speed 500

*/

// GLOBAL VARIABLES
new gHeroName[]="Silver Surfer"
new bool:gHasSurferPower[SH_MAXSLOTS+1]
//-------------------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Silver Surfer", "1.15", "Necroscope")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("surfer_level", "10")
	register_cvar("surfer_speed", "500")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	shCreateHero(gHeroName, "Cosmic Powers", "Endless Noclip, Hold Power Key Down", true, "surfer_level")

	// REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
	// INIT
	register_srvcmd("surfer_init", "surfer_init")
	shRegHeroInit(gHeroName, "surfer_init")

	// NEW SPAWN
	register_event("ResetHUD", "newSpawn", "b")

	// Key Down
	register_srvcmd("surfer_kd", "surfer_kd")
	shRegKeyDown(gHeroName, "surfer_kd")

	// Key Up
	register_srvcmd("surfer_ku", "surfer_ku")
	shRegKeyUp(gHeroName, "surfer_ku")

	// Death
	register_event("DeathMsg", "surfer_death", "a")
}
//-------------------------------------------------------------------------------------------------------
public surfer_init()
{
	// First Argument is an id
	new temp[6]
	read_argv(1, temp, 5)
	new id = str_to_num(temp)

	// 2nd Argument is 0 or 1 depending on whether the id has Surfer Powers
	read_argv(2, temp, 5)
	new hasPowers=str_to_num(temp)

	switch(hasPowers)
	{
		case true:
			gHasSurferPower[id] = true

		case false:
		{
			if ( is_user_alive(id) && gHasSurferPower[id] )
				set_user_noclip(id, 0)

			gHasSurferPower[id] = false
		}
	}
}
//-------------------------------------------------------------------------------------------------------
public newSpawn(id)
{
	if ( is_user_alive(id) && get_user_noclip(id) )
		set_user_noclip(id, 0)
}
//-------------------------------------------------------------------------------------------------------
public surfer_kd()
{
	if ( !hasRoundStarted() )
		return

	// First Argument is an id
	new temp[6]
	read_argv(1, temp, 5)
	new id = str_to_num(temp)

	if ( !gHasSurferPower[id] || !is_user_alive(id) )
		return

	//If the user already has noclip (prob from another hero) cancel this keydown
	if ( get_user_noclip(id) )
	{
		client_print(id, print_chat, "[SH](%s) You are already using noclip", gHeroName)
		playSoundDenySelect(id)
		return
	}

	set_user_noclip(id, 1)
	shSetMaxSpeed(gHeroName, "surfer_speed", "[0]")
	set_user_rendering(id, kRenderFxGlowShell, 200, 200, 200, kRenderTransAlpha, 64)

	// Surfer Message
	set_hudmessage(200, 200, 200, -1.0, 0.3, 0, 0.25, 1.0, 0.0, 0.0, 4)
	show_hudmessage(id, "Entered %s Mode - Don't get Stuck or you will die", gHeroName)
}
//-------------------------------------------------------------------------------------------------------
public surfer_ku()
{
	// First Argument is an id
	new temp[6]
	read_argv(1, temp, 5)
	new id = str_to_num(temp)

	if ( get_user_noclip(id) )
		set_user_noclip(id, 0)

	shRemSpeedPower(id)
	set_user_rendering(id)

	// Surfer Message
	set_hudmessage(200, 200, 200, -1.0, 0.3, 0, 0.25, 1.0, 0.0, 0.0, 4)
	show_hudmessage(id, "%s Mode Now Over", gHeroName)
}
//-------------------------------------------------------------------------------------------------------
public surfer_death()
{
	new id = read_data(2)

	set_user_noclip(id, 0)

	shRemSpeedPower(id)
}
//-------------------------------------------------------------------------------------------------------